#!/bin/sh
# Exit the script if any command fails
set -e

if [ "$1" = 'start' ]; then

  if [ "$WEBCONTEXT" = '/' ]; then
      indexHtmlFilePath="/usr/share/nginx/html/index.html"
      targetPath="/usr/share/nginx/html/assets/configurations"
  else
      mkdir -p /tmp/"$WEBCONTEXT"/
      mv -v /usr/share/nginx/html/* /tmp/"$WEBCONTEXT"/
      rm -rf /usr/share/nginx/html/*
      mkdir -p /usr/share/nginx/html/"$WEBCONTEXT"/
      mv -v /tmp/"$WEBCONTEXT"/* /usr/share/nginx/html/"$WEBCONTEXT"/
      rm -rf /tmp/"$WEBCONTEXT"
      indexHtmlFilePath="/usr/share/nginx/html/"$WEBCONTEXT"/index.html"
      targetPath="/usr/share/nginx/html/$WEBCONTEXT/assets/configurations"
  fi

  sed -i -- 's/href="/href-temp="/g' "$indexHtmlFilePath"
  sed -i -- 's/src="/src-temp="/g' "$indexHtmlFilePath"

  jsonRuntimeFilePath="/usr/share/nginx/environments/environment.runtime.json"
  mkdir -p "$targetPath"

  # Inject environment config to the angular dist assets/ folder
  if [ -e $jsonRuntimeFilePath ]; then
    jq '.dummyClientSecret = $value' --arg value "$CLIENT_SECRET" $jsonRuntimeFilePath >tmp.$$.json \
    && cp tmp.$$.json "$targetPath/environment.runtime.json" \
    && rm -rf tmp.$$.json
  fi

  # Start http server
  exec nginx -g 'daemon off;'
fi

# Used to run a custom command on container start
exec "$@"
