import {adminInstitutionOrganizationalUnitNamespace} from "@admin/institution/stores/organizational-unit/admin-institution-organizational-unit.action";
import {Injectable} from "@angular/core";
import {
  OrganizationalUnit,
} from "@models";
import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {ApiResourceNameEnum} from "@shared/enums/api-resource-name.enum";
import {ApiEnum} from "@shared/enums/api.enum";
import {StateEnum} from "@shared/enums/state.enum";
import {
  ApiService,
  AssociationState,
  AssociationStateModel,
  defaultAssociationStateInitValue,
  NotificationService,
} from "solidify-frontend";

export interface AdminInstitutionOrganizationalUnitStateModel extends AssociationStateModel<OrganizationalUnit> {
}

@Injectable()
@State<AdminInstitutionOrganizationalUnitStateModel>({
  name: StateEnum.admin_institution_organizationalUnit,
  defaults: {
    ...defaultAssociationStateInitValue(),
  },
})
export class AdminInstitutionOrganizationalUnitState extends AssociationState<AdminInstitutionOrganizationalUnitStateModel, OrganizationalUnit> {
  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: adminInstitutionOrganizationalUnitNamespace,
      resourceName: ApiResourceNameEnum.ORG_UNIT,
    });
  }

  protected get _urlResource(): string {
    return ApiEnum.adminInstitutions;
  }
}
