import {
  ChangeDetectionStrategy,
  Component,
  Inject,
} from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialogRef,
} from "@angular/material/dialog";
import {Enums} from "@enums";
import {Store} from "@ngxs/store";
import {SharedAbstractDialog} from "@shared/components/dialogs/shared-abstract/shared-abstract.dialog";

@Component({
  selector: "dlcm-admin-user-edit-role-current-user-dialog",
  templateUrl: "./admin-user-edit-role-current-user.dialog.html",
  styleUrls: ["./admin-user-edit-role-current-user.dialog.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class AdminUserEditRoleCurrentUserDialog extends SharedAbstractDialog<AdminUserEditRoleCurrentUserDialogData, boolean> {
  get userApplicationRoleEnum(): typeof Enums.UserApplicationRole.UserApplicationRoleEnum {
    return Enums.UserApplicationRole.UserApplicationRoleEnum;
  }

  constructor(protected readonly store: Store,
              protected readonly _dialogRef: MatDialogRef<AdminUserEditRoleCurrentUserDialog>,
              @Inject(MAT_DIALOG_DATA) public readonly data: AdminUserEditRoleCurrentUserDialogData) {
    super(_dialogRef, data);
  }

  confirm(): void {
    this.submit(true);
  }
}

export interface AdminUserEditRoleCurrentUserDialogData {
  removedRole: string;
  addedRole: string;
}
