import {DepositDataFile} from "@app/features/deposit/models/deposit-data-file.model";
import {StateEnum} from "@shared/enums/state.enum";
import {
  TypeDefaultAction,
  UploadAction,
  UploadNameSpace,
} from "solidify-frontend";

const state = StateEnum.deposit_upload;

export namespace DepositUploadAction {
  @TypeDefaultAction(state)
  export class UploadFile extends UploadAction.UploadFile {
  }

  @TypeDefaultAction(state)
  export class UploadFileSuccess extends UploadAction.UploadFileSuccess<DepositDataFile> {
  }

  @TypeDefaultAction(state)
  export class UploadFileFail extends UploadAction.UploadFileFail<DepositDataFile> {
  }

  @TypeDefaultAction(state)
  export class MarkAsCancelFileSending extends UploadAction.MarkAsCancelFileSending<DepositDataFile> {
  }

  @TypeDefaultAction(state)
  export class CancelFileSending extends UploadAction.CancelFileSending<DepositDataFile> {
  }

  @TypeDefaultAction(state)
  export class RetrySendFile extends UploadAction.RetrySendFile<DepositDataFile> {
  }
}

export const depositUploadActionNameSpace: UploadNameSpace = DepositUploadAction;
