import {Injectable} from "@angular/core";
import {ApiEnum} from "@app/shared/enums/api.enum";
import {Sip} from "@models";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {StateEnum} from "@shared/enums/state.enum";
import {
  defaultStatusHistoryInitValue,
  StatusHistoryState,
  StatusHistoryStateModel,
} from "@shared/stores/status-history/status-history.state";
import {
  ApiService,
  NotificationService,
} from "solidify-frontend";
import {preservationPlanningDepositStatusHistoryNamespace} from "@preservation-planning/deposit/stores/status-history/preservation-planning-deposit-status-history.action";

export interface PreservationPlanningDepositStatusHistoryStateModel extends StatusHistoryStateModel<Sip> {
}

@Injectable()
@State<PreservationPlanningDepositStatusHistoryStateModel>({
  name: StateEnum.preservationPlanning_deposit_statusHistory,
  defaults: {
    ...defaultStatusHistoryInitValue(),
  },
})
export class PreservationPlanningDepositStatusHistoryState extends StatusHistoryState<PreservationPlanningDepositStatusHistoryStateModel, Sip> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: preservationPlanningDepositStatusHistoryNamespace,
    });
  }

  protected get _urlResource(): string {
    return ApiEnum.preIngestDeposits;
  }
}
