import {
  Directive,
  Input,
} from "@angular/core";
import {
  FloatLabelType,
  MatFormFieldAppearance,
} from "@angular/material/form-field";
import {environment} from "@environments/environment";
import {DataTestEnum} from "@shared/enums/data-test.enum";
import {IconNameEnum} from "@shared/enums/icon-name.enum";
import {LabelTranslateEnum} from "@shared/enums/label-translate.enum";
import {
  AbstractDialog,
  EnumUtil,
} from "solidify-frontend";

@Directive()
export abstract class SharedAbstractDialog<TData, UResult = void> extends AbstractDialog<TData, UResult> {
  @Input()
  paramMessage: any;

  @Input()
  titleToTranslate: string;

  @Input()
  tooltipToTranslate: string;

  get iconNameEnum(): typeof IconNameEnum {
    return IconNameEnum;
  }

  get dataTestEnum(): typeof DataTestEnum {
    return DataTestEnum;
  }

  get labelTranslateEnum(): typeof LabelTranslateEnum {
    return LabelTranslateEnum;
  }

  get enumUtil(): typeof EnumUtil {
    return EnumUtil;
  }

  get appearanceInputMaterial(): MatFormFieldAppearance {
    return environment.appearanceInputMaterial;
  }

  get displayEmptyRequiredFieldInError(): boolean {
    return environment.displayEmptyRequiredFieldInError;
  }

  get positionLabelInputMaterial(): FloatLabelType {
    return environment.positionLabelInputMaterial;
  }
}
