import {
  ChangeDetectionStrategy,
  ChangeDetectorRef,
  Component,
  HostBinding,
  Input,
} from "@angular/core";
import {Enums} from "@enums";
import {SharedAbstractPresentational} from "@shared/components/presentationals/shared-abstract/shared-abstract.presentational";
import {DateUtil} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-access-level-with-embargo",
  templateUrl: "./shared-access-level-with-embargo.presentational.html",
  styleUrls: ["./shared-access-level-with-embargo.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SharedAccessLevelWithEmbargoPresentational extends SharedAbstractPresentational {
  @Input()
  accessLevel: Enums.Deposit.AccessEnum;

  @Input()
  @HostBinding("class.have-embargo")
  embargoAccessLevel: Enums.Deposit.AccessEnum;

  @Input()
  embargoEndDate: Date;

  @Input()
  size: string = "size-24";

  @Input()
  withTooltip: boolean = false;

  get dateUtil(): typeof DateUtil {
    return DateUtil;
  }

  constructor(private readonly _changeDetector: ChangeDetectorRef) {
    super();
  }
}
