import {
  ChangeDetectionStrategy,
  Component,
  Input,
} from "@angular/core";
import {SharedAbstractPresentational} from "@app/shared/components/presentationals/shared-abstract/shared-abstract.presentational";
import {Enums} from "@enums";
import {
  ClipboardUtil,
  EnumUtil,
  MARK_AS_TRANSLATABLE,
  NotificationService,
} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-checksum-item",
  templateUrl: "./shared-checksum-item.presentational.html",
  styleUrls: ["./shared-checksum-item.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SharedChecksumItemPresentational extends SharedAbstractPresentational {
  @Input()
  checksumAlgo: Enums.DataFile.ChecksumAlgoEnum;

  @Input()
  checksumOrigin: Enums.DataFile.ChecksumOriginEnum;

  @Input()
  checksum: string;

  get checksumOriginEnumTranslate(): typeof Enums.DataFile.ChecksumOriginEnumTranslate {
    return Enums.DataFile.ChecksumOriginEnumTranslate;
  }

  get enumUtil(): typeof EnumUtil {
    return EnumUtil;
  }

  constructor(private readonly _notificationService: NotificationService) {
    super();
  }

  copy(checksum: string): void {
    ClipboardUtil.copyStringToClipboard(checksum);
    this._notificationService.showInformation(MARK_AS_TRANSLATABLE("app.notification.checksumCopy"));
  }
}
