import {Enums} from "@enums";
import {
  AipChecksumCheck,
  AipFileFormat,
  ChangeInfo,
  Checksum,
  MetadataType,
} from "@models";
import {BaseResource} from "solidify-frontend";

export interface DataFile<TPackage extends BaseResource = any> {
  resId?: string;
  creation?: ChangeInfo;
  lastUpdate?: ChangeInfo;
  sourceData?: string;
  status?: Enums.DataFile.StatusEnum;
  statusMessage?: string;
  virusCheck?: AipChecksumCheck;
  smartSize?: string;
  relativeLocation?: string;
  initialPath?: string;
  finalData?: string;
  fileSize?: number;
  fileName?: string;
  fileFormat?: AipFileFormat;
  dataCategory?: Enums.DataFile.DataCategoryEnum;
  dataType?: Enums.DataFile.DataTypeEnum;
  metadataType?: MetadataType;
  complianceLevel?: string;
  checksums?: Checksum[];
  available?: boolean;
  infoPackage?: TPackage;
}
