import {
  getNames,
  LocalizedLanguageNames,
  registerLocale,
  toAlpha3T,
} from "@cospired/i18n-iso-languages";
import {Enums} from "@enums";
import {AdminLanguage} from "@shared/models/admin-language.model";

declare const require: any;

export class RegionUtil {

  static getLanguagesWithIsoCode(currentLanguage: Enums.Language.LanguageEnum): AdminLanguage[] {
    registerLocale(require("@cospired/i18n-iso-languages/langs/" + currentLanguage + ".json"));

    const listLanguages: LocalizedLanguageNames = getNames(currentLanguage);
    return Object.entries(listLanguages).map(([k, v]) => ({iso: k.toUpperCase(), name: v, iso3: toAlpha3T(k).toUpperCase()}));
  }
}
