import {StateEnum} from "@shared/enums/state.enum";
import {
  BannerColorEnum,
  SolidifyObject,
} from "solidify-frontend";

const state = StateEnum.application_banner;

export namespace AppBannerAction {
  export class Show {
    static readonly type: string = `[${state}] Show`;

    constructor(public message: string, public color: BannerColorEnum, public parameters: SolidifyObject = {}) {
    }
  }

  export class ShowInEditMode {
    static readonly type: string = `[${state}] Show In Edit Mode`;
  }

  export class Hide {
    static readonly type: string = `[${state}] Hide`;
  }
}

export const appBannerActionNameSpace = AppBannerAction;
