import {Enums} from "@enums";
import {ViewModeTableEnum} from "@shared/enums/view-mode-table.enum";
import {DefaultSolidifyEnvironment} from "solidify-frontend";

export interface DlcmEnvironment extends DefaultSolidifyEnvironment {
  googleAnalyticsLearnMorePage: string;
  displayPrivacyPolicyAndTermsOfUseApprovalDialog: boolean;
  privacyPolicyLink: string;
  termsOfUseLink: string;

  // Base URL For Module Applications (override by AppAction.LoadModules)
  preservation_planning?: string | undefined;
  authorization?: string | undefined;
  admin: string;
  ingest?: string | undefined;
  preingest?: string | undefined;
  access?: string | undefined;
  oaiInfo?: string | undefined;
  archivalStorage?: string[] | undefined;
  dataManagement?: string | undefined;
  index?: string | undefined;

  defaultStorageIndex: number;
  archivalStorageName: string[];

  // Documentation
  documentationTocApisGuide: string | undefined;
  documentationTocIntegrationGuide: string | undefined;
  documentationTocToolsGuide: string | undefined;
  documentationTocUserGuidePath: string | undefined;
  documentationTocUserGuide: string | undefined;

  // Orcid properties
  orcidQueryParam: string;
  orcidAuthorizeUrl: string;
  orcidUrl: string;

  // Access request
  accessRequestRoute: string;

  // Others
  institutionUrl: string;

  // Home
  carouselUrl: string | undefined;
  defaultPageSizeHomePage: number;
  defaultHomeOrgUnitSize: number;
  defaultHomeViewModeTableEnum: ViewModeTableEnum;
  frequencyChangeCarouselTileInSecond: number;
  twitterAccount: string;
  twitterTweetToDisplay: number;

  urlNationalArchivePronom: string;

  doiLink: string;
  oaiProviderUrlEnd: string;

  // Polling
  refreshTabStatusCounterIntervalInSecond: number;
  refreshOrderAvailableIntervalInSecond: number;
  refreshNotificationInboxAvailableIntervalInSecond: number;
  refreshDepositSubmittedIntervalInSecond: number;
  refreshSipProcessIntervalInSecond: number;

  fileSizeLimitForChecksumGenerationInMegabytes: number;

  listFacetUseOperatorAnd: Enums.Facet.Name[];
}
