import {enableProdMode} from "@angular/core";
import {platformBrowserDynamic} from "@angular/platform-browser-dynamic";

import {AppModule} from "./app/app.module";
import {environment} from "./environments/environment";

declare const readyToBootstrap: Promise<void>;

if (environment.production) {
  enableProdMode();
}

readyToBootstrap.then(() => {
  platformBrowserDynamic().bootstrapModule(AppModule)
    // eslint-disable-next-line no-console
    .catch(err => console.error(err));
});
